﻿@inherits LayoutComponentBase

<PageTitle>JWobot Admin</PageTitle>

<div id="wrapper">
    <AuthorizeView>
        <Authorized>
            <NavMenu />
        </Authorized>
    </AuthorizeView>
    <div id="content-wrapper" class="d-flex flex-column">

        <div id="content">
            <AuthorizeView>
                <Authorized>
                    <nav class="navbar navbar-expand navbar-light bg-white topbar mb-4 static-top shadow">

                        <button id="sidebarToggleTop" class="btn btn-link d-md-none rounded-circle mr-3">
                            <i class="fa fa-bars"></i>
                        </button>

                        <ul class="navbar-nav ml-auto">

                            <div class="topbar-divider d-none d-sm-block"></div>

                            <li class="nav-item dropdown no-arrow">
                                <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button"
                                   data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <span class="mr-2 d-none d-lg-inline text-gray-600 small">@fullName</span>
                                    <img class="img-profile rounded-circle"
                                         src="image/undraw_profile.svg">
                                </a>
                                <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in"
                                     aria-labelledby="userDropdown">
                                    <a class="dropdown-item" href="#">
                                        <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                                        Profile
                                    </a>
                                    <div class="dropdown-divider"></div>
                                    <a class="dropdown-item" href="login" @onclick="(() => Logout())">
                                        <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                                        Logout
                                    </a>
                                </div>
                            </li>

                        </ul>

                    </nav>
                </Authorized>
            </AuthorizeView>
            <div class="container-fluid">
                @Body
            </div>

        </div>
        <AuthorizeView>
            <Authorized>
                <footer class="sticky-footer bg-white">
                    <div class="container my-auto">
                        <div class="copyright text-center my-auto">
                            <span>Copyright &copy; JWobot Admin 2023</span>
                        </div>
                    </div>
                </footer>
            </Authorized>
        </AuthorizeView>

    </div>
</div>
@code
{
    protected async override Task OnAfterRenderAsync(bool firstRender)
    {
        if (firstRender)
        {
            await JS.InitSidebarToggle();
            await JS.ChangeBodyClass("page-top");
        }
    }
    [CascadingParameter]
    private Task<AuthenticationState> authenticationStateTask { get; set; }
    private string fullName;


    protected async override Task OnInitializedAsync()
    {
        var claimsPrincipal = (await authenticationStateTask).User;
        if (claimsPrincipal != null && claimsPrincipal.Identity.IsAuthenticated)
        {
            fullName = claimsPrincipal.FindFirst("Fullname").Value;
        }
    }

    public void Logout()
    {
        ((CustomAuthenticationStateProvider)AuthenticationStateProvider).MarkUserAsLoggedOut();
    }
}
